//+------------------------------------------------------------------+
//|                                                 			 PriceStat |
//|                               Copyright  2010-2011, FXMaster.de |
//|     programming & support - Alexey Sergeev (profy.mql@gmail.com) |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010-2011, FXMaster.de"
#property link      "profy.mql@gmail.com | Alex Sergeev"

#property indicator_chart_window
#property indicator_color1 SkyBlue
#property indicator_color2 YellowGreen
#property indicator_color3 Tomato

extern int gTF=1; //  , 0-
extern double Discret=1; //    
extern double Width=30; //   ( )
extern bool Present=true; //    (  )
extern double Future=1; //        ( )
extern double Past=1; //        ( )
extern bool bVolume=false; //      Volume
extern string inf0="Sup/Res line";
extern int nAvg=20; //    , 0-  
extern double Deviat=20; //     /    Deviat %
extern bool bExtrem=true; //     

bool first;
string g_inf;
datetime pdt1, pdt2;
string gsID;
//-------------------------------------------------------  init
int init() { first=true; gsID="stat"; pdt1=0; pdt2=0; return(0); }
//-------------------------------------------------------  deinit
int deinit() { ObjectsDeleteAll2(0, -1, gsID); }
//-------------------------------------------------------  start
int start()
{
	g_inf="";
	main();
	Comment(g_inf);
}
//-------------------------------------------------------  main
void main()
{
	string smb=Symbol();
	int tf=Period(); if (gTF!=0) tf=gTF;
	
	string name[]; int n=ObjectSelect(0, OBJ_VLINE, "", name);
	if (n!=2) { INF("-    2"); return; }
	double from=ObjectGet(name[0], OBJPROP_TIME1); 
	double to=ObjectGet(name[1], OBJPROP_TIME1);
	
	datetime dt; if (from<to) { dt=from; from=to; to=dt; }
	int w=GetWidth(smb, tf, from, to);

	if (pdt1!=from || pdt2!=to) first=true;
	if (!first) return; //   ,  
	first=false; pdt1=from; pdt2=to;
	double hi, lo, pr[]; 

	if (Present) DrawHistogram(smb, tf, gsID+"pres", from, to, indicator_color1, w);
	if (Future>0) DrawHistogram(smb, tf, gsID+"future", from+(from-to)*Future, from, indicator_color2, w, from, 1);
	if (Past>0) DrawHistogram(smb, tf, gsID+"past", to, to-(from-to)*Past, indicator_color3, w, to, -1);
}
//------------------------------------------------------------------ Draw
void DrawHistogram(string smb, int tf, string sID, datetime from, datetime to, color clr, double w, datetime dt=0, int k=0)
{
	double pr[]; double hi, lo; int i;
	int n=GetStat(smb, tf, from, to, pr, hi, lo); 
	ObjectsDeleteAll2(0, OBJ_TREND, sID); // 
	SetLine(sID+"Hi", from, hi*Point, to, hi*Point, clr, 1, STYLE_DOT, "");
	SetLine(sID+"Lo", from, lo*Point, to, lo*Point, clr, 1, STYLE_DOT, "");
	if (k==0)
	{
		for (i=0; i<n; i++) SetLine(sID+i+"L", from, (i*Discret+lo)*Point, from-pr[i]*w, (i*Discret+lo)*Point, clr, 1, STYLE_SOLID, "");
		for (i=0; i<n; i++) SetLine(sID+i+"R", to, (i*Discret+lo)*Point, to+pr[i]*w, (i*Discret+lo)*Point, clr, 1, STYLE_SOLID, "");
	}
	else
		for (i=0; i<n; i++) SetLine(sID+i, dt, (i*Discret+lo)*Point, dt+k*pr[i]*w, (i*Discret+lo)*Point, clr, 1, STYLE_SOLID, "");
	
	//   
	if (bExtrem) SetHLine(sID+"ES", (ArrayMaximum(pr)*Discret+lo)*Point, clr, 2, STYLE_SOLID, "ex small");
	
	if (nAvg>0)
	{
		bool exHi[], exLo[]; //      (  )
		ArrayResize(exHi, n); ArrayResize(exLo, n); ArrayInitialize(exHi, false); ArrayInitialize(exLo, false); 
		double avg_pr[]; //   
		ArrayResize(avg_pr, n);
		for (i=nAvg; i<n; i++) avg_pr[i]=iMAOnArray(pr, 0, nAvg, 0, MODE_EMA, i); // 
		
		for (i=nAvg; i<n-nAvg; i++) //   MA avg_pr 
		{
			bool b=true; int j;
			if (avg_pr[i]>Deviat/100)
			{
				for (j=0; j<nAvg; j++) 
				{
					if (avg_pr[i+j]>avg_pr[i] || exHi[i+j]) { b=false; break; } //  
					if (avg_pr[i-j]>avg_pr[i] || exHi[i-j]) { b=false; break; } //  
				}
				if (b)
				{
					for (j=i+1; j<n; j++) { if (avg_pr[i]!=avg_pr[j]) break; exHi[j]=false; } //   
					for (j=i-1; j>=0; j--) { if (avg_pr[i]!=avg_pr[j]) break; exHi[j]=false; }
					exHi[i]=true; //   
				}
			}
			if (avg_pr[i]<Deviat/100)
			{
				b=true;
				for (j=0; j<nAvg; j++) 
				{
					if (avg_pr[i+j]<avg_pr[i] || exLo[i+j]) { b=false; break; } //  
					if (avg_pr[i-j]<avg_pr[i] || exLo[i-j]) { b=false; break; } //  
				}
				if (b)
				{
					for (j=i+1; j<n; j++) { if (avg_pr[i]!=avg_pr[j]) break; exLo[j]=false; }  //   
					for (j=i-1; j>=0; j--) { if (avg_pr[i]!=avg_pr[j]) break; exLo[j]=false; }
					exLo[i]=true; //   
				}
			}
		}
		for (i=0; i<n; i++) //  
		{
			if (exHi[i]) SetHLine(sID+"exHi"+i, (i*Discret+lo)*Point, clr, 1, STYLE_SOLID, "");
			if (exLo[i]) SetHLine(sID+"exLo"+i, (i*Discret+lo)*Point, clr, 1, STYLE_DOT, "");
		}
	}
}
//------------------------------------------------------------------ GetWidth
int GetWidth(string smb, int tf, datetime from, datetime to)
{
	int b1=iBarShift(smb, tf, from);
	int b2=iBarShift(smb, tf, to);
	double pr=iHigh(smb, tf, iHighest(smb, tf, MODE_HIGH, b2-b1+1, b1))/Point;

	string name=gsID+"metr";
	if (ObjectFind(name)<0) SetLine(name, from, pr*Point, from-Width*60*Period(), pr*Point, SkyBlue, 3, STYLE_SOLID, "");
	datetime dt1=ObjectGet(name, OBJPROP_TIME1); b1=iBarShift(smb, tf, dt1);
	datetime dt2=ObjectGet(name, OBJPROP_TIME2); b2=iBarShift(smb, tf, dt2);
	int w=MathAbs(b1-b2)*60*tf;
	if (ObjectGet(name, OBJPROP_TIME1)!=from) SetLine(name, from, pr*Point, from-w, pr*Point, SkyBlue, 3, STYLE_SOLID, "");
	return(w);
}
//------------------------------------------------------------------ GetStat
int GetStat(string smb, int tf, datetime from, datetime to, double &pr[], double &hi, double &lo)
{
	//    
	int b1=iBarShift(smb, tf, from);
	int b2=iBarShift(smb, tf, to);
	//  
	hi=iHigh(smb, tf, iHighest(smb, tf, MODE_HIGH, b2-b1+1, b1))/Point;
	lo=iLow(smb, tf, iLowest(smb, tf, MODE_LOW, b2-b1+1, b1))/Point;
	// 
	int n=(hi-lo)/Discret; if (n<=0) { INF("-n==0"); return; }
	INF("n="+n);
	ArrayResize(pr, n); ArrayInitialize(pr, 0);
	for (int b=b1; b<=b2; b++) //  
	{
		int ll=(iLow(smb, tf, b)/Point-lo)/Discret; int hh=(iHigh(smb, tf, b)/Point-lo)/Discret;
		for (int i=ll; i<=hh; i++) if (!bVolume) pr[i]++; else pr[i]+=iVolume(smb, tf, b); 
	}
	// 
	i=ArrayMinimum(pr); double m=pr[i]; for (i=0; i<n; i++) pr[i]-=m-1;
	i=ArrayMaximum(pr); m=pr[i]; for (i=0; i<n; i++) pr[i]=pr[i]/m;
	return(n);
}
//------------------------------------------------------------------ SetLine
void SetLine(string name, datetime dt1, double pr1, datetime dt2, double pr2, color clr, int width, int style, string st)
{
	ObjectCreate(name, OBJ_TREND, 0, 0, 0); ObjectSet(name, OBJPROP_RAY, false);
	ObjectSet(name, OBJPROP_TIME1, dt1); ObjectSet(name, OBJPROP_PRICE1, pr1);
	ObjectSet(name, OBJPROP_TIME2, dt2); ObjectSet(name, OBJPROP_PRICE2, pr2);
	ObjectSet(name, OBJPROP_WIDTH, width); ObjectSet(name, OBJPROP_COLOR, clr);
	ObjectSetText(name, st); ObjectSet(name, OBJPROP_STYLE, style);
}
//------------------------------------------------------------------ SetHLine
void SetHLine(string name, double pr, color clr, int width, int style, string st)
{
	ObjectCreate(name, OBJ_HLINE, 0, 0, 0); ObjectSet(name, OBJPROP_PRICE1, pr);
	ObjectSet(name, OBJPROP_WIDTH, width); ObjectSet(name, OBJPROP_COLOR, clr);
	ObjectSetText(name, st); ObjectSet(name, OBJPROP_STYLE, style);
}
//------------------------------------------------------------------ ObjectSelect
int ObjectSelect(int wnd, int type, string pref, string &name[])
{
	string names[]; int k=0, n=ObjectsTotal(); ArrayResize(names, n);
	for (int i=0; i<n; i++) 
	{
		string st=ObjectName(i);
		if (wnd>=0) if (ObjectFind(st)!=wnd) continue;
		if (type>=0) if (ObjectType(st)!=type) continue;
		if (pref!="") if (StringSubstr(st, 0, StringLen(pref))!=pref) continue;
		names[k]=st; k++;
	}
	ArrayResize(name, k);
	for (i=0; i<k; i++) name[i]=names[i]; return(k);
}
//------------------------------------------------------------------ ObjectsDeleteAll2
void ObjectsDeleteAll2(int wnd=-1, int type=-1, string pref="")
{
	string names[]; int n=ObjectsTotal(); ArrayResize(names, n);
	for (int i=0; i<n; i++) names[i]=ObjectName(i);
	for (i=0; i<n; i++) 
	{
		if (wnd>=0) if (ObjectFind(names[i])!=wnd) continue;
		if (type>=0) if (ObjectType(names[i])!=type) continue;
		if (pref!="") if (StringSubstr(names[i], 0, StringLen(pref))!=pref) continue;
		ObjectDelete(names[i]);
	}
}
//---------------------------------------------------------------   INF
void INF(string st, bool ini=false) { if (ini) g_inf=g_inf+"\n        "+st; else g_inf=g_inf+"\n            "+st; }

